#ifndef MemoryBuffer_H
#define MemoryBuffer_H

class MemoryBuffer
    {
    public:
        MemoryBuffer()
            :   m_lpbDynamicMemory( NULL )
        {
        }
        virtual ~MemoryBuffer()
        {
            ReleaseMemory();
        }

        LPQUERY_SERVICE_CONFIG QueryServiceConfig(SC_HANDLE hService);
        LPCTSTR GetServiceDescription(SC_HANDLE hService);
        LPSERVICE_STATUS_PROCESS QueryServiceStatusEx(SC_HANDLE hService);

    protected:
        void ReleaseMemory();

        typedef BOOL (WINAPI MemoryBuffer::*LPFNMethod)(LPBYTE lpbMemory, DWORD dwSize);
        LPVOID StandardProcess(LPFNMethod func);
        BOOL WINAPI IGetServiceDescription(LPBYTE lpbMemory, DWORD dwSize);
        BOOL WINAPI IQueryServiceConfig(LPBYTE lpbMemory, DWORD dwSize);
        BOOL WINAPI IQueryServiceStatusEx(LPBYTE lpbMemory, DWORD dwSize);

        SC_HANDLE m_hService;
        DWORD m_dwBytesNeeded;
        LPBYTE m_lpbDynamicMemory;
        BYTE m_bStaticMemory[4096];
    };




#endif // MemoryBuffer_H
